#include <stdio.h>                      /* For printf and so on. */
#include <Xm/Text.h>
#include <Mrm/MrmAppl.h>                /* Motif Toolkit and MRM */
#include <X11/X.h>

/* The vuit generated application include file.				    */
/* If the user does not specify a directory for the file		    */
/* then the vaxc$include logical needs to be defined to point to the	    */
/* directory of the include file.					    */
#include "XTS.h"
#include "xtsu_database.h"

/*
 * Global data
 */
static MrmType class_id;		/* Place to keep class ID*/
static MrmType *dummy_class;            /* and class variable. */
static char *db_filename_vec[] =        /* Mrm.hierachy file list. */
  {
"XTS.uid"
  };
static int db_filename_num =
                (sizeof db_filename_vec / sizeof db_filename_vec [0]);
char *vuit_dummy_ident_value = "VUIT dummy identifier value";
int i;
#define hash_table_limit 500
struct HASH_TABLE_STRUCT
    {
    char	*widget_name;
    Widget	id;
    } hash_table[hash_table_limit + 1];

/*
 * Forward declarations
 */
void xts_exit();
void xts_list();
void xts_customise_cancel();
void xts_customise_ok();
void xts_exit_ok();
void xts_customise();
void xts_exit_cancel();
void xts_clear_day_cancel();
void xts_clear_day_ok();
void xts_clear_week();
void xts_load();
void xts_load_cancel();
void xts_load_ok();
void xts_save_cancel();
void xts_save_ok();
void xts_save();
void xts_customise_apply();
void xts_entry_ok();
void xts_entry_apply();
void xts_entry_cancel();
void xts_entry_create();
void xts_entry();
void xts_entry_edit();
void xts_entry_delete_cancel();
void xts_entry_delete_ok();
void xts_entry_delete();
void xts_export_cancel();
void xts_export_ok();
void xts_charging();
void xts_focus();
void xts_list_create();
void xts_register_widget();
void xts_save_settings();
void xts_save_quick();
void xts_clear_day();
void xts_clear_week_cancel();
void xts_clear_week_ok();
void xts_export_decplan();
void xts_restore_settings();
void xts_use_defaults();
void xts_busy();
void xts_not_busy();
void xts_help_on_tasks();
void xts_help_on_version();
void xts_window_list();
void xts_window_list_ok();
void xts_window_list_apply();
void xts_window_list_cancel();
void xts_window_list_delete();
void xts_window_list_select();
void xts_window_list_create();
void xts_ignore_this_window();
void xts_help_clear_day();
void xts_help_clear_week();
void xts_quit_ok();
void xts_export_cssts();
void xts_bare_message_box();
void xts_copyright_off();
void xts_reflist_activate();
void xts_reflist_create();
void xts_reflist_reload();
void xts_reflist_ok();

/*
 * Names and addresses of callback routines to register with Mrm
 */
static MrmRegisterArg reglist [] = {
{"xts_exit", (caddr_t)xts_exit},
{"xts_list", (caddr_t)xts_list},
{"xts_customise_cancel", (caddr_t)xts_customise_cancel},
{"xts_customise_ok", (caddr_t)xts_customise_ok},
{"xts_exit_ok", (caddr_t)xts_exit_ok},
{"xts_customise", (caddr_t)xts_customise},
{"xts_exit_cancel", (caddr_t)xts_exit_cancel},
{"xts_clear_day_cancel", (caddr_t)xts_clear_day_cancel},
{"xts_clear_day_ok", (caddr_t)xts_clear_day_ok},
{"xts_clear_week", (caddr_t)xts_clear_week},
{"xts_load", (caddr_t)xts_load},
{"xts_load_cancel", (caddr_t)xts_load_cancel},
{"xts_load_ok", (caddr_t)xts_load_ok},
{"xts_save_cancel", (caddr_t)xts_save_cancel},
{"xts_save_ok", (caddr_t)xts_save_ok},
{"xts_save", (caddr_t)xts_save},
{"xts_customise_apply", (caddr_t)xts_customise_apply},
{"xts_entry_ok", (caddr_t)xts_entry_ok},
{"xts_entry_apply", (caddr_t)xts_entry_apply},
{"xts_entry_cancel", (caddr_t)xts_entry_cancel},
{"xts_entry_create", (caddr_t)xts_entry_create},
{"xts_entry", (caddr_t)xts_entry},
{"xts_entry_edit", (caddr_t)xts_entry_edit},
{"xts_entry_delete_cancel", (caddr_t)xts_entry_delete_cancel},
{"xts_entry_delete_ok", (caddr_t)xts_entry_delete_ok},
{"xts_entry_delete", (caddr_t)xts_entry_delete},
{"xts_export_cancel", (caddr_t)xts_export_cancel},
{"xts_export_ok", (caddr_t)xts_export_ok},
{"xts_charging", (caddr_t)xts_charging},
{"xts_focus", (caddr_t)xts_focus},
{"xts_list_create", (caddr_t)xts_list_create},
{"xts_register_widget", (caddr_t)xts_register_widget},
{"xts_save_settings", (caddr_t)xts_save_settings},
{"xts_save_quick", (caddr_t)xts_save_quick},
{"xts_clear_day", (caddr_t)xts_clear_day},
{"xts_clear_week_cancel", (caddr_t)xts_clear_week_cancel},
{"xts_clear_week_ok", (caddr_t)xts_clear_week_ok},
{"xts_export_decplan", (caddr_t)xts_export_decplan},
{"xts_restore_settings", (caddr_t)xts_restore_settings},
{"xts_use_defaults", (caddr_t)xts_use_defaults},
{"xts_busy", (caddr_t)xts_busy},
{"xts_not_busy", (caddr_t)xts_not_busy},
{"xts_help_on_tasks", (caddr_t)xts_help_on_tasks},
{"xts_help_on_version", (caddr_t)xts_help_on_version},
{"xts_window_list", (caddr_t)xts_window_list},
{"xts_window_list_ok", (caddr_t)xts_window_list_ok},
{"xts_window_list_apply", (caddr_t)xts_window_list_apply},
{"xts_window_list_cancel", (caddr_t)xts_window_list_cancel},
{"xts_window_list_delete", (caddr_t)xts_window_list_delete},
{"xts_window_list_select", (caddr_t)xts_window_list_select},
{"xts_window_list_create", (caddr_t)xts_window_list_create},
{"xts_ignore_this_window", (caddr_t)xts_ignore_this_window},
{"xts_help_clear_day", (caddr_t)xts_help_clear_day},
{"xts_help_clear_week", (caddr_t)xts_help_clear_week},
{"xts_quit_ok", (caddr_t)xts_quit_ok},
{"xts_export_cssts", (caddr_t)xts_export_cssts},
{"xts_bare_message_box", (caddr_t)xts_bare_message_box},
{"xts_copyright_off", (caddr_t)xts_copyright_off},
{"xts_reflist_activate", (caddr_t)xts_reflist_activate},
{"xts_reflist_create", (caddr_t)xts_reflist_create},
{"xts_reflist_reload", (caddr_t)xts_reflist_reload},
{"xts_reflist_ok", (caddr_t)xts_reflist_ok}};

static int reglist_num = (sizeof reglist / sizeof reglist[0]);

/*
 * Names and addresses of uil identifiers (if any) to register with Mrm.
 * These identifiers are registered with a dummy value to allow the generated 
 * code to run without error.
 * You can avoid the registration of these identifiers by simplying editing
 * this template file (vuit_main_template_c) and removing the following
 * special format comments:
 *	***VUIT ident registration***
 *	***VUIT identlist size***
 *	***VUIT register identifiers***
 * You can provide your own registration of identifiers by calling your own
 * routine in response to a callback (such as the MrmNcreateCallback for your
 * application's main window), or by modifying this template to call your
 * own registration routine.
 */



/*
 * OS transfer point.  The main routine does all the one-time setup and
 * then calls XtAppMainLoop.
 */
unsigned int main(argc, argv)
    unsigned int argc;                  /* Command line argument count. */
    char *argv[];                       /* Pointers to command line args. */
{
    Arg arglist[2];
    int n;

    MrmInitialize();
    DXmInitialize();
    XtToolkitInitialize();
    app_context = XtCreateApplicationContext();
    display = XtOpenDisplay(app_context, NULL, "xts", "Xts",
                            NULL, 0, &argc, argv);
    if (display == NULL) 
	{
        fprintf(stderr, "%s:  Can't open display\n", argv[0]);
        exit(1);
	}
    xtsu_db_set_database ( display->db );

    n = 0;
    XtSetArg(arglist[n], XmNallowShellResize, True);  n++;
    toplevel_widget = XtAppCreateShell("XTS", "Xts", applicationShellWidgetClass,
                              display, arglist, n);

    /*
    **  Open the Motif Resource Manager file
    */
    {
        char *file = xtsu_db_get_string ( "Xts.hierarchy", "XTS.uid" );
        if
        (
            MrmOpenHierarchy
            (
                1,
                &file,
                NULL,               
                &s_MrmHierarchy     /* Pointer to returned MRM ID */
            ) !=MrmSUCCESS
        )
        {
            printf("can't open hierarchy, make sure the resource file points to the uid file\n");
            exit(0);
        }
    }

MrmRegisterNames (reglist, reglist_num);


VUIT_Manage("w_mw");

    /* 
     * Realize the top level widget.  All managed children now become visible
     */
    XtRealizeWidget(toplevel_widget);
    xtsu_copyright_on();

    xtsu_start(argv[1],argv[2]);

    /* 
     * Sit around forever waiting to process X-events.  We never leave
     * XtAppMainLoop. From here on, we only execute our callback routines. 
     */
    XtAppMainLoop(app_context);
}


/*
 * All errors are fatal.
 */
void s_error(problem_string)
    char *problem_string;
{
    printf("%s\n", problem_string);
    exit(0);
}

/*
**  Fetch the widget from the hierarchy, but don't manage it
**  (not supplied in the original VUIT template)
*/
void VUIT_Read(widget_name)
    char	*widget_name;
{
    Widget		id;

    if (!HashLookup(widget_name, &id))
	{
	MrmFetchWidget(s_MrmHierarchy, widget_name, toplevel_widget, &id, 
	    &class_id);
	HashRegister(widget_name, id);
	}
}

void VUIT_Manage(widget_name)
    char	*widget_name;
{
    Widget		id;
    Window		pop_window;
    XWindowChanges	values;

    if (HashLookup(widget_name, &id))
	if (XtIsManaged(id))
	    {
	    pop_window = XtWindow(XtParent(id));
	    values.x = values.y = values.width = values.height =
		values.border_width = values.sibling = NULL;
	    values.stack_mode = Above;
	    XConfigureWindow(display, pop_window, CWStackMode, &values);
	    }
	else
	    XtManageChild(id);
    else
	{
	MrmFetchWidget(s_MrmHierarchy, widget_name, toplevel_widget, &id, 
	    &class_id);
	XtManageChild(id);
	HashRegister(widget_name, id);
	}
}

void VUIT_Unmanage(widget_name)
    char	*widget_name;
{
    Widget	id;

    if (HashLookup(widget_name, &id))
	XtUnmanageChild(id);
}

int HashRegister (widget_name, id)
    char		*widget_name;
    Widget		id;    
{
    int			ndx;

    for (ndx = HashFunction(widget_name, hash_table_limit);
	((hash_table[ndx].widget_name != NULL) &&
	    (ndx < hash_table_limit));
	ndx++);
    if (hash_table[ndx].widget_name != NULL)
	for (ndx = 0;
	    hash_table[ndx].widget_name != NULL;
	    ndx++);
    if (ndx > hash_table_limit)
	return (FALSE);
    else
	{
	hash_table[ndx].widget_name = XtCalloc(1, strlen(widget_name) + 1);
	strcpy(hash_table[ndx].widget_name, widget_name);
	hash_table[ndx].id = id;
	return (TRUE);
	}
}


int HashLookup (name, id)
    char		*name;
    Widget		*id;
{
    int			ndx;

    for (ndx = HashFunction(name, hash_table_limit);
	((hash_table[ndx].widget_name != NULL) &&
	    (ndx <= hash_table_limit));
	ndx++)
	if (strcmp(name, hash_table[ndx].widget_name) == 0)
	    {
	    *id = hash_table[ndx].id;
	    return (TRUE);
	    }

    if (ndx > hash_table_limit)
	for (ndx = 0;
	    ((hash_table[ndx].widget_name != NULL) &&
		(ndx <= hash_table_limit));
	    ndx++)
	    {
	    if (strcmp(name, hash_table[ndx].widget_name) == 0)
		{
	 	*id = hash_table[ndx].id;
		return (TRUE);
		}
	    }

    return (FALSE);
}

int HashFunction (name, max)
    char		*name;
    int			max;

{
#define HashVecSize		20	/* plenty for 31 character names */
typedef union
    {
    short int		intname[HashVecSize];	 /* name as vector of ints */
    char		charname[2*HashVecSize]; /* name as vector of chars */
    } HashName;

    HashName		locname;	/* aligned name */
    int			namelen;	/* length of name */
    int			namelim;	/* length limit (fullword size) */
    int			namextra;	/* limit factor remainder */
    int			code = 0;	/* hash code value */
    int			ndx;		/* loop index */


    /*
     * Copy the name into the local aligned union.
     * Process the name as a vector of integers, with some remaining characters.
     * The string is copied into a local union in order to force correct
     * alignment for alignment-sensitive processors.
     */
    strcpy (locname.charname, name);
    namelen = strlen (locname.charname);
    namelim = namelen >> 1;		/* divide by 2 */
    namextra = namelen & 1;		/* remainder */

    /*
     * XOR each integer part of the name together, followed by the trailing
     * 0/1 character
     */
    for ( ndx=0 ; ndx<namelim ; ndx++ )
        code = code ^ ((locname.intname[ndx])<<ndx);
    if ( namextra > 0 )
        code = code ^ ((locname.intname[ndx])&0x00FF);

    return (code&0x7FFF) % max;
}


void xts_exit (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Manage("w_qd_exit");
}

void xts_list (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_list(w, tag, reason);
}

void xts_customise_cancel (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Unmanage("w_fd_customise");
}

void xts_customise_ok (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_customise_apply(w, tag, reason);
VUIT_Unmanage("w_fd_customise");
}

void xts_exit_ok (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Unmanage("w_qd_exit");
VUIT_Unmanage("w_mw");
xtsu_exit(w, tag, reason);
exit(0);
}

void xts_customise (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_busy(w, tag, reason);
XmUpdateDisplay(w, tag, reason);
VUIT_Manage("w_fd_customise");
xtsu_customise(w, tag, reason);
xtsu_not_busy(w, tag, reason);
}

void xts_exit_cancel (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Unmanage("w_qd_exit");
}

void xts_clear_day_cancel (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Unmanage("w_wd_clear_day");
}

void xts_clear_day_ok (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_clear_day_ok(w, tag, reason);
VUIT_Unmanage("w_wd_clear_day");
}

void xts_clear_week (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
XmUpdateDisplay(w, tag, reason);
VUIT_Manage("w_wd_clear_week");
}

void xts_load (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
XmUpdateDisplay(w, tag, reason);
VUIT_Manage("w_fsd_load");
}

void xts_load_cancel (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Unmanage("w_fsd_load");
}

void xts_load_ok (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_load(w, tag, reason);
VUIT_Unmanage("w_fsd_load");
}

void xts_save_cancel (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Unmanage("w_fsd_save");
}

void xts_save_ok (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_save(w, tag, reason);
VUIT_Unmanage("w_fsd_save");
}

void xts_save (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
XmUpdateDisplay(w, tag, reason);
VUIT_Manage("w_fsd_save");
}

void xts_customise_apply (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_customise_apply(w, tag, reason);
}

void xts_entry_ok (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_entry_apply(w, tag, reason);
VUIT_Unmanage("w_fd_entry");
}

void xts_entry_apply (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_entry_apply(w, tag, reason);
}

void xts_entry_cancel (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Unmanage("w_fd_entry");
}

void xts_entry_create (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_entry_create(w, tag, reason);
}

void xts_entry (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
XmUpdateDisplay(w, tag, reason);
xtsu_busy(w, tag, reason);
VUIT_Manage("w_fd_entry");
xtsu_not_busy(w, tag, reason);
}

void xts_entry_edit (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_entry_edit(w, tag, reason);
}

void xts_entry_delete_cancel (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Unmanage("w_qd_entry_delete");
}

void xts_entry_delete_ok (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_entry_delete_ok(w, tag, reason);
VUIT_Unmanage("w_qd_entry_delete");
}

void xts_entry_delete (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Manage("w_qd_entry_delete");
}

void xts_export_cancel (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Unmanage("w_id_extract");
}

void xts_export_ok (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Unmanage("w_id_extract");
}

void xts_charging (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_charging(w, tag, reason);
}

void xts_focus (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_focus(w, tag, reason);
}

void xts_list_create (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_list_create(w, tag, reason);
}

void xts_register_widget (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
HashRegister(XtName(w), w);
}

void xts_save_settings (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_save_settings(w, tag, reason);
}

void xts_save_quick (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_save_quick(w, tag, reason);
}

void xts_clear_day (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
XmUpdateDisplay(w, tag, reason);
VUIT_Manage("w_wd_clear_day");
}

void xts_clear_week_cancel (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Unmanage("w_wd_clear_week");
}

void xts_clear_week_ok (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Unmanage("w_wd_clear_week");
xtsu_clear_week_ok(w, tag, reason);
}

void xts_export_decplan (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_export_decplan(w, tag, reason);
VUIT_Manage("w_id_extract");
}

void xts_restore_settings (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_restore_settings(w, tag, reason);
}

void xts_use_defaults (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_use_defaults(w, tag, reason);
}

void xts_busy (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_busy(w, tag, reason);
}

void xts_not_busy (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_not_busy(w, tag, reason);
}

void xts_help_on_tasks (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
XmUpdateDisplay(w, tag, reason);
VUIT_Manage("w_h_on_tasks");
}

void xts_help_on_version (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
XmUpdateDisplay(w, tag, reason);
VUIT_Manage("w_h_on_version");
}

void xts_window_list (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Manage("w_fd_window_list");
xtsu_window_list(w, tag, reason);
}

void xts_window_list_ok (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Unmanage("w_fd_window_list");
}

void xts_window_list_apply (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Unmanage("w_fd_window_list");
}

void xts_window_list_cancel (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Unmanage("w_fd_window_list");
}

void xts_window_list_delete (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_window_list_delete(w, tag, reason);
}

void xts_window_list_select (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_window_list_select(w, tag, reason);
}

void xts_window_list_create (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_window_list_create(w, tag, reason);
}

void xts_ignore_this_window (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_ignore_this_window(w, tag, reason);
}

void xts_help_clear_day (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
XmUpdateDisplay(w, tag, reason);
VUIT_Manage("w_h_clear_day");
}

void xts_help_clear_week (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
XmUpdateDisplay(w, tag, reason);
VUIT_Manage("w_h_clear_week");
}

void xts_quit_ok (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Unmanage("w_mw");
xtsu_quit(w, tag, reason);
exit(0);
}

void xts_export_cssts (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_export_cssts(w, tag, reason);
VUIT_Manage("w_id_extract");
}

void xts_bare_message_box (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_bare_message_box(w, tag, reason);
xtsu_ignore_this_window(w, tag, reason);
}

void xts_copyright_off (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_copyright_off(w, tag, reason);
}

void xts_reflist_activate (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
VUIT_Manage("w_sd_reflist");
}

void xts_reflist_create (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_reflist_create(w, tag, reason);
}

void xts_reflist_reload (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_reflist_reload(w, tag, reason);
}

void xts_reflist_ok (w, tag, reason)
Widget		w;
int		*tag;
unsigned long	*reason;
{
xtsu_reflist_ok(w, tag, reason);
}

